/************************************************************************
 *  Mxxxx.C								*
 *			Befehle fr Prozessor xxxx fr X51		*
 *			==================================		*
 *									*
 *  xx.xx.93	Bodo Wenzel	V1.0, Erstellung			*
 ************************************************************************/

#pragma code symbols small debug

/* === Einfgedateien ================================================= */

#include <regxxxx.h>
#include <stdio.h>

#include "utility.h"
#include "command.h"
#include "m_all.h"
#include "mxxxx.h"
#include "rs232.h"

/* === Globale Variablen ============================================== */

enum {	ID_PO=ID_SPECIAL, ID_PI, ID_... };

/* === Funktionsprototypen ============================================ */

static entry *m_port_out(bit doit);
static entry *m_port_inp(bit doit);
static entry *m_...(bit doit);

/* === Funktionen ===================================================== */

bit mxxxx_look(void) {
/*------------------*/
if ((cmd_entry=m_port_out(FALSE))!=0)
  return(TRUE);
if ((cmd_entry=m_port_inp(FALSE))!=0)
  return(TRUE);
if ((cmd_entry=m_...(FALSE))!=0)
  return(TRUE);
return(FALSE);
}

void mxxxx_doit(uchar id) {
/*-----------------------*/
switch (id) {
case ID_PO:
  m_port_out(TRUE);
  break;
case ID_PI:
  m_port_inp(TRUE);
  break;
case ID_...:
  m_...(TRUE);
  break;
default:
  break;
  }
}

void mxxxx_help(void) {
/*-------------------*/
rs232_puts("\nPOp,d write port (p=port, d=data)");
rs232_puts("\nPIp   read port (p=port)");
rs232_puts("\n...");
}

void mxxxx_init(void) {
/*-------------------*/
}

/* --- Port-Befehle --------------------------------------------------- */

static entry *m_port_out(bit doit) {
/*--------------------------------*/
entry	code	e = { ID_PO, T_DEZ, 0, 3, T_HEX, 0x00, 0xFF };
uint		p,d;

if (!doit) {
  if (cmd_c1=='P' && cmd_c2=='O')
    return(&e);
  else
    return(0);
  }
p=*((uint *)cmd_act);
cmd_act+=2;
d=*((uint *)cmd_act);
cmd_act+=2;
switch (p) {
case 0:
  P0=(uchar)d;
  break;
case 1:
  P1=(uchar)d;
  break;
case 2:
  P2=(uchar)d;
  break;
case 3:
  P3=(uchar)d;
  break;
default:
  break;
  }
return(0);
}

static entry *m_port_inp(bit doit) {
/*--------------------------------*/
entry	code	e = { ID_PI, T_DEZ, 0, 3, T_NONE, 0, 0 };
uint		p;

if (!doit) {
  if (cmd_c1=='P' && cmd_c2=='I')
    return(&e);
  else
    return(0);
  }
p=*((uint *)cmd_act);
cmd_act+=2;
putchar('\n');
switch (p) {
case 0:
  rs232_putx(P0,FALSE);
  break;
case 1:
  rs232_putx(P1,FALSE);
  break;
case 2:
  rs232_putx(P2,FALSE);
  break;
case 3:
  rs232_putx(P3,FALSE);
  break;
default:
  break;
  }
return(0);
}

static entry *m_...(bit doit) {
/*--------------------------------*/
entry	code	e = { ID_..., T_NONE, 0, 0, T_NONE, 0, 0 };

if (!doit) {
  if (cmd_c1=='' && cmd_c2=='')
    return(&e);
  else
    return(0);
  }
...
return(0);
}

/* === Ende =========================================================== */
