/************************************************************************
 *  SFR.C								*
 *			SFR-Funktionen fr X51				*
 *			======================				*
 *									*
 *  14.06.93	Bodo Wenzel	V1.0, Erstellung			*
 ************************************************************************/

#pragma code symbols small debug

/* === Einfgedateien ================================================= */

#include "utility.h"
#include "sfr.h"

/* === Vereinbarungen ================================================= */

sfr  R80  =0x80;   sfr  R81  =0x81;   sfr  R82  =0x82;   sfr  R83  =0x83;
sfr  R84  =0x84;   sfr  R85  =0x85;   sfr  R86  =0x86;   sfr  R87  =0x87;
sfr  R88  =0x88;   sfr  R89  =0x89;   sfr  R8A  =0x8A;   sfr  R8B  =0x8B;
sfr  R8C  =0x8C;   sfr  R8D  =0x8D;   sfr  R8E  =0x8E;   sfr  R8F  =0x8F;
sfr  R90  =0x90;   sfr  R91  =0x91;   sfr  R92  =0x92;   sfr  R93  =0x93;
sfr  R94  =0x94;   sfr  R95  =0x95;   sfr  R96  =0x96;   sfr  R97  =0x97;
sfr  R98  =0x98;   sfr  R99  =0x99;   sfr  R9A  =0x9A;   sfr  R9B  =0x9B;
sfr  R9C  =0x9C;   sfr  R9D  =0x9D;   sfr  R9E  =0x9E;   sfr  R9F  =0x9F;
sfr  RA0  =0xA0;   sfr  RA1  =0xA1;   sfr  RA2  =0xA2;   sfr  RA3  =0xA3;
sfr  RA4  =0xA4;   sfr  RA5  =0xA5;   sfr  RA6  =0xA6;   sfr  RA7  =0xA7;
sfr  RA8  =0xA8;   sfr  RA9  =0xA9;   sfr  RAA  =0xAA;   sfr  RAB  =0xAB;
sfr  RAC  =0xAC;   sfr  RAD  =0xAD;   sfr  RAE  =0xAE;   sfr  RAF  =0xAF;
sfr  RB0  =0xB0;   sfr  RB1  =0xB1;   sfr  RB2  =0xB2;   sfr  RB3  =0xB3;
sfr  RB4  =0xB4;   sfr  RB5  =0xB5;   sfr  RB6  =0xB6;   sfr  RB7  =0xB7;
sfr  RB8  =0xB8;   sfr  RB9  =0xB9;   sfr  RBA  =0xBA;   sfr  RBB  =0xBB;
sfr  RBC  =0xBC;   sfr  RBD  =0xBD;   sfr  RBE  =0xBE;   sfr  RBF  =0xBF;
sfr  RC0  =0xC0;   sfr  RC1  =0xC1;   sfr  RC2  =0xC2;   sfr  RC3  =0xC3;
sfr  RC4  =0xC4;   sfr  RC5  =0xC5;   sfr  RC6  =0xC6;   sfr  RC7  =0xC7;
sfr  RC8  =0xC8;   sfr  RC9  =0xC9;   sfr  RCA  =0xCA;   sfr  RCB  =0xCB;
sfr  RCC  =0xCC;   sfr  RCD  =0xCD;   sfr  RCE  =0xCE;   sfr  RCF  =0xCF;
sfr  RD0  =0xD0;   sfr  RD1  =0xD1;   sfr  RD2  =0xD2;   sfr  RD3  =0xD3;
sfr  RD4  =0xD4;   sfr  RD5  =0xD5;   sfr  RD6  =0xD6;   sfr  RD7  =0xD7;
sfr  RD8  =0xD8;   sfr  RD9  =0xD9;   sfr  RDA  =0xDA;   sfr  RDB  =0xDB;
sfr  RDC  =0xDC;   sfr  RDD  =0xDD;   sfr  RDE  =0xDE;   sfr  RDF  =0xDF;
sfr  RE0  =0xE0;   sfr  RE1  =0xE1;   sfr  RE2  =0xE2;   sfr  RE3  =0xE3;
sfr  RE4  =0xE4;   sfr  RE5  =0xE5;   sfr  RE6  =0xE6;   sfr  RE7  =0xE7;
sfr  RE8  =0xE8;   sfr  RE9  =0xE9;   sfr  REA  =0xEA;   sfr  REB  =0xEB;
sfr  REC  =0xEC;   sfr  RED  =0xED;   sfr  REE  =0xEE;   sfr  REF  =0xEF;
sfr  RF0  =0xF0;   sfr  RF1  =0xF1;   sfr  RF2  =0xF2;   sfr  RF3  =0xF3;
sfr  RF4  =0xF4;   sfr  RF5  =0xF5;   sfr  RF6  =0xF6;   sfr  RF7  =0xF7;
sfr  RF8  =0xF8;   sfr  RF9  =0xF9;   sfr  RFA  =0xFA;   sfr  RFB  =0xFB;
sfr  RFC  =0xFC;   sfr  RFD  =0xFD;   sfr  RFE  =0xFE;   sfr  RFF  =0xFF;

sbit B80  =0x80;   sbit B81  =0x81;   sbit B82  =0x82;   sbit B83  =0x83;
sbit B84  =0x84;   sbit B85  =0x85;   sbit B86  =0x86;   sbit B87  =0x87;
sbit B88  =0x88;   sbit B89  =0x89;   sbit B8A  =0x8A;   sbit B8B  =0x8B;
sbit B8C  =0x8C;   sbit B8D  =0x8D;   sbit B8E  =0x8E;   sbit B8F  =0x8F;
sbit B90  =0x90;   sbit B91  =0x91;   sbit B92  =0x92;   sbit B93  =0x93;
sbit B94  =0x94;   sbit B95  =0x95;   sbit B96  =0x96;   sbit B97  =0x97;
sbit B98  =0x98;   sbit B99  =0x99;   sbit B9A  =0x9A;   sbit B9B  =0x9B;
sbit B9C  =0x9C;   sbit B9D  =0x9D;   sbit B9E  =0x9E;   sbit B9F  =0x9F;
sbit BA0  =0xA0;   sbit BA1  =0xA1;   sbit BA2  =0xA2;   sbit BA3  =0xA3;
sbit BA4  =0xA4;   sbit BA5  =0xA5;   sbit BA6  =0xA6;   sbit BA7  =0xA7;
sbit BA8  =0xA8;   sbit BA9  =0xA9;   sbit BAA  =0xAA;   sbit BAB  =0xAB;
sbit BAC  =0xAC;   sbit BAD  =0xAD;   sbit BAE  =0xAE;   sbit BAF  =0xAF;
sbit BB0  =0xB0;   sbit BB1  =0xB1;   sbit BB2  =0xB2;   sbit BB3  =0xB3;
sbit BB4  =0xB4;   sbit BB5  =0xB5;   sbit BB6  =0xB6;   sbit BB7  =0xB7;
sbit BB8  =0xB8;   sbit BB9  =0xB9;   sbit BBA  =0xBA;   sbit BBB  =0xBB;
sbit BBC  =0xBC;   sbit BBD  =0xBD;   sbit BBE  =0xBE;   sbit BBF  =0xBF;
sbit BC0  =0xC0;   sbit BC1  =0xC1;   sbit BC2  =0xC2;   sbit BC3  =0xC3;
sbit BC4  =0xC4;   sbit BC5  =0xC5;   sbit BC6  =0xC6;   sbit BC7  =0xC7;
sbit BC8  =0xC8;   sbit BC9  =0xC9;   sbit BCA  =0xCA;   sbit BCB  =0xCB;
sbit BCC  =0xCC;   sbit BCD  =0xCD;   sbit BCE  =0xCE;   sbit BCF  =0xCF;
sbit BD0  =0xD0;   sbit BD1  =0xD1;   sbit BD2  =0xD2;   sbit BD3  =0xD3;
sbit BD4  =0xD4;   sbit BD5  =0xD5;   sbit BD6  =0xD6;   sbit BD7  =0xD7;
sbit BD8  =0xD8;   sbit BD9  =0xD9;   sbit BDA  =0xDA;   sbit BDB  =0xDB;
sbit BDC  =0xDC;   sbit BDD  =0xDD;   sbit BDE  =0xDE;   sbit BDF  =0xDF;
sbit BE0  =0xE0;   sbit BE1  =0xE1;   sbit BE2  =0xE2;   sbit BE3  =0xE3;
sbit BE4  =0xE4;   sbit BE5  =0xE5;   sbit BE6  =0xE6;   sbit BE7  =0xE7;
sbit BE8  =0xE8;   sbit BE9  =0xE9;   sbit BEA  =0xEA;   sbit BEB  =0xEB;
sbit BEC  =0xEC;   sbit BED  =0xED;   sbit BEE  =0xEE;   sbit BEF  =0xEF;
sbit BF0  =0xF0;   sbit BF1  =0xF1;   sbit BF2  =0xF2;   sbit BF3  =0xF3;
sbit BF4  =0xF4;   sbit BF5  =0xF5;   sbit BF6  =0xF6;   sbit BF7  =0xF7;
sbit BF8  =0xF8;   sbit BF9  =0xF9;   sbit BFA  =0xFA;   sbit BFB  =0xFB;
sbit BFC  =0xFC;   sbit BFD  =0xFD;   sbit BFE  =0xFE;   sbit BFF  =0xFF;

/* === Funktionen ===================================================== */

void sfr_out(uchar sfr_r,uchar d) {
/*-------------------------------*/
switch (sfr_r) {
case 0x80:	R80=d;	break;
case 0x81:	R81=d;	break;
case 0x82:	R82=d;	break;
case 0x83:	R83=d;	break;
case 0x84:	R84=d;	break;
case 0x85:	R85=d;	break;
case 0x86:	R86=d;	break;
case 0x87:	R87=d;	break;
case 0x88:	R88=d;	break;
case 0x89:	R89=d;	break;
case 0x8A:	R8A=d;	break;
case 0x8B:	R8B=d;	break;
case 0x8C:	R8C=d;	break;
case 0x8D:	R8D=d;	break;
case 0x8E:	R8E=d;	break;
case 0x8F:	R8F=d;	break;
case 0x90:	R90=d;	break;
case 0x91:	R91=d;	break;
case 0x92:	R92=d;	break;
case 0x93:	R93=d;	break;
case 0x94:	R94=d;	break;
case 0x95:	R95=d;	break;
case 0x96:	R96=d;	break;
case 0x97:	R97=d;	break;
case 0x98:	R98=d;	break;
case 0x99:	R99=d;	break;
case 0x9A:	R9A=d;	break;
case 0x9B:	R9B=d;	break;
case 0x9C:	R9C=d;	break;
case 0x9D:	R9D=d;	break;
case 0x9E:	R9E=d;	break;
case 0x9F:	R9F=d;	break;
case 0xA0:	RA0=d;	break;
case 0xA1:	RA1=d;	break;
case 0xA2:	RA2=d;	break;
case 0xA3:	RA3=d;	break;
case 0xA4:	RA4=d;	break;
case 0xA5:	RA5=d;	break;
case 0xA6:	RA6=d;	break;
case 0xA7:	RA7=d;	break;
case 0xA8:	RA8=d;	break;
case 0xA9:	RA9=d;	break;
case 0xAA:	RAA=d;	break;
case 0xAB:	RAB=d;	break;
case 0xAC:	RAC=d;	break;
case 0xAD:	RAD=d;	break;
case 0xAE:	RAE=d;	break;
case 0xAF:	RAF=d;	break;
case 0xB0:	RB0=d;	break;
case 0xB1:	RB1=d;	break;
case 0xB2:	RB2=d;	break;
case 0xB3:	RB3=d;	break;
case 0xB4:	RB4=d;	break;
case 0xB5:	RB5=d;	break;
case 0xB6:	RB6=d;	break;
case 0xB7:	RB7=d;	break;
case 0xB8:	RB8=d;	break;
case 0xB9:	RB9=d;	break;
case 0xBA:	RBA=d;	break;
case 0xBB:	RBB=d;	break;
case 0xBC:	RBC=d;	break;
case 0xBD:	RBD=d;	break;
case 0xBE:	RBE=d;	break;
case 0xBF:	RBF=d;	break;
case 0xC0:	RC0=d;	break;
case 0xC1:	RC1=d;	break;
case 0xC2:	RC2=d;	break;
case 0xC3:	RC3=d;	break;
case 0xC4:	RC4=d;	break;
case 0xC5:	RC5=d;	break;
case 0xC6:	RC6=d;	break;
case 0xC7:	RC7=d;	break;
case 0xC8:	RC8=d;	break;
case 0xC9:	RC9=d;	break;
case 0xCA:	RCA=d;	break;
case 0xCB:	RCB=d;	break;
case 0xCC:	RCC=d;	break;
case 0xCD:	RCD=d;	break;
case 0xCE:	RCE=d;	break;
case 0xCF:	RCF=d;	break;
case 0xD0:	RD0=d;	break;
case 0xD1:	RD1=d;	break;
case 0xD2:	RD2=d;	break;
case 0xD3:	RD3=d;	break;
case 0xD4:	RD4=d;	break;
case 0xD5:	RD5=d;	break;
case 0xD6:	RD6=d;	break;
case 0xD7:	RD7=d;	break;
case 0xD8:	RD8=d;	break;
case 0xD9:	RD9=d;	break;
case 0xDA:	RDA=d;	break;
case 0xDB:	RDB=d;	break;
case 0xDC:	RDC=d;	break;
case 0xDD:	RDD=d;	break;
case 0xDE:	RDE=d;	break;
case 0xDF:	RDF=d;	break;
case 0xE0:	RE0=d;	break;
case 0xE1:	RE1=d;	break;
case 0xE2:	RE2=d;	break;
case 0xE3:	RE3=d;	break;
case 0xE4:	RE4=d;	break;
case 0xE5:	RE5=d;	break;
case 0xE6:	RE6=d;	break;
case 0xE7:	RE7=d;	break;
case 0xE8:	RE8=d;	break;
case 0xE9:	RE9=d;	break;
case 0xEA:	REA=d;	break;
case 0xEB:	REB=d;	break;
case 0xEC:	REC=d;	break;
case 0xED:	RED=d;	break;
case 0xEE:	REE=d;	break;
case 0xEF:	REF=d;	break;
case 0xF0:	RF0=d;	break;
case 0xF1:	RF1=d;	break;
case 0xF2:	RF2=d;	break;
case 0xF3:	RF3=d;	break;
case 0xF4:	RF4=d;	break;
case 0xF5:	RF5=d;	break;
case 0xF6:	RF6=d;	break;
case 0xF7:	RF7=d;	break;
case 0xF8:	RF8=d;	break;
case 0xF9:	RF9=d;	break;
case 0xFA:	RFA=d;	break;
case 0xFB:	RFB=d;	break;
case 0xFC:	RFC=d;	break;
case 0xFD:	RFD=d;	break;
case 0xFE:	RFE=d;	break;
case 0xFF:	RFF=d;	break;
default:		break;
  }
}

uchar sfr_inp(uchar sfr_r) {
/*------------------------*/
switch (sfr_r) {
case 0x80:	return(R80);
case 0x81:	return(R81);
case 0x82:	return(R82);
case 0x83:	return(R83);
case 0x84:	return(R84);
case 0x85:	return(R85);
case 0x86:	return(R86);
case 0x87:	return(R87);
case 0x88:	return(R88);
case 0x89:	return(R89);
case 0x8A:	return(R8A);
case 0x8B:	return(R8B);
case 0x8C:	return(R8C);
case 0x8D:	return(R8D);
case 0x8E:	return(R8E);
case 0x8F:	return(R8F);
case 0x90:	return(R90);
case 0x91:	return(R91);
case 0x92:	return(R92);
case 0x93:	return(R93);
case 0x94:	return(R94);
case 0x95:	return(R95);
case 0x96:	return(R96);
case 0x97:	return(R97);
case 0x98:	return(R98);
case 0x99:	return(R99);
case 0x9A:	return(R9A);
case 0x9B:	return(R9B);
case 0x9C:	return(R9C);
case 0x9D:	return(R9D);
case 0x9E:	return(R9E);
case 0x9F:	return(R9F);
case 0xA0:	return(RA0);
case 0xA1:	return(RA1);
case 0xA2:	return(RA2);
case 0xA3:	return(RA3);
case 0xA4:	return(RA4);
case 0xA5:	return(RA5);
case 0xA6:	return(RA6);
case 0xA7:	return(RA7);
case 0xA8:	return(RA8);
case 0xA9:	return(RA9);
case 0xAA:	return(RAA);
case 0xAB:	return(RAB);
case 0xAC:	return(RAC);
case 0xAD:	return(RAD);
case 0xAE:	return(RAE);
case 0xAF:	return(RAF);
case 0xB0:	return(RB0);
case 0xB1:	return(RB1);
case 0xB2:	return(RB2);
case 0xB3:	return(RB3);
case 0xB4:	return(RB4);
case 0xB5:	return(RB5);
case 0xB6:	return(RB6);
case 0xB7:	return(RB7);
case 0xB8:	return(RB8);
case 0xB9:	return(RB9);
case 0xBA:	return(RBA);
case 0xBB:	return(RBB);
case 0xBC:	return(RBC);
case 0xBD:	return(RBD);
case 0xBE:	return(RBE);
case 0xBF:	return(RBF);
case 0xC0:	return(RC0);
case 0xC1:	return(RC1);
case 0xC2:	return(RC2);
case 0xC3:	return(RC3);
case 0xC4:	return(RC4);
case 0xC5:	return(RC5);
case 0xC6:	return(RC6);
case 0xC7:	return(RC7);
case 0xC8:	return(RC8);
case 0xC9:	return(RC9);
case 0xCA:	return(RCA);
case 0xCB:	return(RCB);
case 0xCC:	return(RCC);
case 0xCD:	return(RCD);
case 0xCE:	return(RCE);
case 0xCF:	return(RCF);
case 0xD0:	return(RD0);
case 0xD1:	return(RD1);
case 0xD2:	return(RD2);
case 0xD3:	return(RD3);
case 0xD4:	return(RD4);
case 0xD5:	return(RD5);
case 0xD6:	return(RD6);
case 0xD7:	return(RD7);
case 0xD8:	return(RD8);
case 0xD9:	return(RD9);
case 0xDA:	return(RDA);
case 0xDB:	return(RDB);
case 0xDC:	return(RDC);
case 0xDD:	return(RDD);
case 0xDE:	return(RDE);
case 0xDF:	return(RDF);
case 0xE0:	return(RE0);
case 0xE1:	return(RE1);
case 0xE2:	return(RE2);
case 0xE3:	return(RE3);
case 0xE4:	return(RE4);
case 0xE5:	return(RE5);
case 0xE6:	return(RE6);
case 0xE7:	return(RE7);
case 0xE8:	return(RE8);
case 0xE9:	return(RE9);
case 0xEA:	return(REA);
case 0xEB:	return(REB);
case 0xEC:	return(REC);
case 0xED:	return(RED);
case 0xEE:	return(REE);
case 0xEF:	return(REF);
case 0xF0:	return(RF0);
case 0xF1:	return(RF1);
case 0xF2:	return(RF2);
case 0xF3:	return(RF3);
case 0xF4:	return(RF4);
case 0xF5:	return(RF5);
case 0xF6:	return(RF6);
case 0xF7:	return(RF7);
case 0xF8:	return(RF8);
case 0xF9:	return(RF9);
case 0xFA:	return(RFA);
case 0xFB:	return(RFB);
case 0xFC:	return(RFC);
case 0xFD:	return(RFD);
case 0xFE:	return(RFE);
case 0xFF:	return(RFF);
default:	return(0x00);
  }
}

void sfr_set(uchar sfr_b,bit d) {
/*-----------------------------*/
switch (sfr_b) {
case 0x80:	B80=d;	break;
case 0x81:	B81=d;	break;
case 0x82:	B82=d;	break;
case 0x83:	B83=d;	break;
case 0x84:	B84=d;	break;
case 0x85:	B85=d;	break;
case 0x86:	B86=d;	break;
case 0x87:	B87=d;	break;
case 0x88:	B88=d;	break;
case 0x89:	B89=d;	break;
case 0x8A:	B8A=d;	break;
case 0x8B:	B8B=d;	break;
case 0x8C:	B8C=d;	break;
case 0x8D:	B8D=d;	break;
case 0x8E:	B8E=d;	break;
case 0x8F:	B8F=d;	break;
case 0x90:	B90=d;	break;
case 0x91:	B91=d;	break;
case 0x92:	B92=d;	break;
case 0x93:	B93=d;	break;
case 0x94:	B94=d;	break;
case 0x95:	B95=d;	break;
case 0x96:	B96=d;	break;
case 0x97:	B97=d;	break;
case 0x98:	B98=d;	break;
case 0x99:	B99=d;	break;
case 0x9A:	B9A=d;	break;
case 0x9B:	B9B=d;	break;
case 0x9C:	B9C=d;	break;
case 0x9D:	B9D=d;	break;
case 0x9E:	B9E=d;	break;
case 0x9F:	B9F=d;	break;
case 0xA0:	BA0=d;	break;
case 0xA1:	BA1=d;	break;
case 0xA2:	BA2=d;	break;
case 0xA3:	BA3=d;	break;
case 0xA4:	BA4=d;	break;
case 0xA5:	BA5=d;	break;
case 0xA6:	BA6=d;	break;
case 0xA7:	BA7=d;	break;
case 0xA8:	BA8=d;	break;
case 0xA9:	BA9=d;	break;
case 0xAA:	BAA=d;	break;
case 0xAB:	BAB=d;	break;
case 0xAC:	BAC=d;	break;
case 0xAD:	BAD=d;	break;
case 0xAE:	BAE=d;	break;
case 0xAF:	BAF=d;	break;
case 0xB0:	BB0=d;	break;
case 0xB1:	BB1=d;	break;
case 0xB2:	BB2=d;	break;
case 0xB3:	BB3=d;	break;
case 0xB4:	BB4=d;	break;
case 0xB5:	BB5=d;	break;
case 0xB6:	BB6=d;	break;
case 0xB7:	BB7=d;	break;
case 0xB8:	BB8=d;	break;
case 0xB9:	BB9=d;	break;
case 0xBA:	BBA=d;	break;
case 0xBB:	BBB=d;	break;
case 0xBC:	BBC=d;	break;
case 0xBD:	BBD=d;	break;
case 0xBE:	BBE=d;	break;
case 0xBF:	BBF=d;	break;
case 0xC0:	BC0=d;	break;
case 0xC1:	BC1=d;	break;
case 0xC2:	BC2=d;	break;
case 0xC3:	BC3=d;	break;
case 0xC4:	BC4=d;	break;
case 0xC5:	BC5=d;	break;
case 0xC6:	BC6=d;	break;
case 0xC7:	BC7=d;	break;
case 0xC8:	BC8=d;	break;
case 0xC9:	BC9=d;	break;
case 0xCA:	BCA=d;	break;
case 0xCB:	BCB=d;	break;
case 0xCC:	BCC=d;	break;
case 0xCD:	BCD=d;	break;
case 0xCE:	BCE=d;	break;
case 0xCF:	BCF=d;	break;
case 0xD0:	BD0=d;	break;
case 0xD1:	BD1=d;	break;
case 0xD2:	BD2=d;	break;
case 0xD3:	BD3=d;	break;
case 0xD4:	BD4=d;	break;
case 0xD5:	BD5=d;	break;
case 0xD6:	BD6=d;	break;
case 0xD7:	BD7=d;	break;
case 0xD8:	BD8=d;	break;
case 0xD9:	BD9=d;	break;
case 0xDA:	BDA=d;	break;
case 0xDB:	BDB=d;	break;
case 0xDC:	BDC=d;	break;
case 0xDD:	BDD=d;	break;
case 0xDE:	BDE=d;	break;
case 0xDF:	BDF=d;	break;
case 0xE0:	BE0=d;	break;
case 0xE1:	BE1=d;	break;
case 0xE2:	BE2=d;	break;
case 0xE3:	BE3=d;	break;
case 0xE4:	BE4=d;	break;
case 0xE5:	BE5=d;	break;
case 0xE6:	BE6=d;	break;
case 0xE7:	BE7=d;	break;
case 0xE8:	BE8=d;	break;
case 0xE9:	BE9=d;	break;
case 0xEA:	BEA=d;	break;
case 0xEB:	BEB=d;	break;
case 0xEC:	BEC=d;	break;
case 0xED:	BED=d;	break;
case 0xEE:	BEE=d;	break;
case 0xEF:	BEF=d;	break;
case 0xF0:	BF0=d;	break;
case 0xF1:	BF1=d;	break;
case 0xF2:	BF2=d;	break;
case 0xF3:	BF3=d;	break;
case 0xF4:	BF4=d;	break;
case 0xF5:	BF5=d;	break;
case 0xF6:	BF6=d;	break;
case 0xF7:	BF7=d;	break;
case 0xF8:	BF8=d;	break;
case 0xF9:	BF9=d;	break;
case 0xFA:	BFA=d;	break;
case 0xFB:	BFB=d;	break;
case 0xFC:	BFC=d;	break;
case 0xFD:	BFD=d;	break;
case 0xFE:	BFE=d;	break;
case 0xFF:	BFF=d;	break;
default:		break;
  }
}

bit sfr_test(uchar sfr_b) {
/*-----------------------*/
switch (sfr_b) {
case 0x80:	return(B80);
case 0x81:	return(B81);
case 0x82:	return(B82);
case 0x83:	return(B83);
case 0x84:	return(B84);
case 0x85:	return(B85);
case 0x86:	return(B86);
case 0x87:	return(B87);
case 0x88:	return(B88);
case 0x89:	return(B89);
case 0x8A:	return(B8A);
case 0x8B:	return(B8B);
case 0x8C:	return(B8C);
case 0x8D:	return(B8D);
case 0x8E:	return(B8E);
case 0x8F:	return(B8F);
case 0x90:	return(B90);
case 0x91:	return(B91);
case 0x92:	return(B92);
case 0x93:	return(B93);
case 0x94:	return(B94);
case 0x95:	return(B95);
case 0x96:	return(B96);
case 0x97:	return(B97);
case 0x98:	return(B98);
case 0x99:	return(B99);
case 0x9A:	return(B9A);
case 0x9B:	return(B9B);
case 0x9C:	return(B9C);
case 0x9D:	return(B9D);
case 0x9E:	return(B9E);
case 0x9F:	return(B9F);
case 0xA0:	return(BA0);
case 0xA1:	return(BA1);
case 0xA2:	return(BA2);
case 0xA3:	return(BA3);
case 0xA4:	return(BA4);
case 0xA5:	return(BA5);
case 0xA6:	return(BA6);
case 0xA7:	return(BA7);
case 0xA8:	return(BA8);
case 0xA9:	return(BA9);
case 0xAA:	return(BAA);
case 0xAB:	return(BAB);
case 0xAC:	return(BAC);
case 0xAD:	return(BAD);
case 0xAE:	return(BAE);
case 0xAF:	return(BAF);
case 0xB0:	return(BB0);
case 0xB1:	return(BB1);
case 0xB2:	return(BB2);
case 0xB3:	return(BB3);
case 0xB4:	return(BB4);
case 0xB5:	return(BB5);
case 0xB6:	return(BB6);
case 0xB7:	return(BB7);
case 0xB8:	return(BB8);
case 0xB9:	return(BB9);
case 0xBA:	return(BBA);
case 0xBB:	return(BBB);
case 0xBC:	return(BBC);
case 0xBD:	return(BBD);
case 0xBE:	return(BBE);
case 0xBF:	return(BBF);
case 0xC0:	return(BC0);
case 0xC1:	return(BC1);
case 0xC2:	return(BC2);
case 0xC3:	return(BC3);
case 0xC4:	return(BC4);
case 0xC5:	return(BC5);
case 0xC6:	return(BC6);
case 0xC7:	return(BC7);
case 0xC8:	return(BC8);
case 0xC9:	return(BC9);
case 0xCA:	return(BCA);
case 0xCB:	return(BCB);
case 0xCC:	return(BCC);
case 0xCD:	return(BCD);
case 0xCE:	return(BCE);
case 0xCF:	return(BCF);
case 0xD0:	return(BD0);
case 0xD1:	return(BD1);
case 0xD2:	return(BD2);
case 0xD3:	return(BD3);
case 0xD4:	return(BD4);
case 0xD5:	return(BD5);
case 0xD6:	return(BD6);
case 0xD7:	return(BD7);
case 0xD8:	return(BD8);
case 0xD9:	return(BD9);
case 0xDA:	return(BDA);
case 0xDB:	return(BDB);
case 0xDC:	return(BDC);
case 0xDD:	return(BDD);
case 0xDE:	return(BDE);
case 0xDF:	return(BDF);
case 0xE0:	return(BE0);
case 0xE1:	return(BE1);
case 0xE2:	return(BE2);
case 0xE3:	return(BE3);
case 0xE4:	return(BE4);
case 0xE5:	return(BE5);
case 0xE6:	return(BE6);
case 0xE7:	return(BE7);
case 0xE8:	return(BE8);
case 0xE9:	return(BE9);
case 0xEA:	return(BEA);
case 0xEB:	return(BEB);
case 0xEC:	return(BEC);
case 0xED:	return(BED);
case 0xEE:	return(BEE);
case 0xEF:	return(BEF);
case 0xF0:	return(BF0);
case 0xF1:	return(BF1);
case 0xF2:	return(BF2);
case 0xF3:	return(BF3);
case 0xF4:	return(BF4);
case 0xF5:	return(BF5);
case 0xF6:	return(BF6);
case 0xF7:	return(BF7);
case 0xF8:	return(BF8);
case 0xF9:	return(BF9);
case 0xFA:	return(BFA);
case 0xFB:	return(BFB);
case 0xFC:	return(BFC);
case 0xFD:	return(BFD);
case 0xFE:	return(BFE);
case 0xFF:	return(BFF);
default:	return(FALSE);
  }
}

/* === Ende =========================================================== */
